import javax.swing.*;
import java.awt.*;

public abstract class Duemilanove extends Core {
	/**
	 * This function constructs the frontend and by using Core#add() registers the pin and what it is capable of
	 */
	public void setupBoard () {
		final Dimension d4 = new Dimension(getWidth(), getHeight() / 4);
		final Dimension d2 = new Dimension(getWidth(), getHeight() / 2);

		final JPanel north = new JPanel();
		north.setLayout(new GridLayout()); // Just don't use the default layout!
		add(north, new DigitalIO(13));
		add(north, new DigitalIO(12));
		add(north, new DigitalIO_PWMOut(11));
		add(north, new DigitalIO_PWMOut(10));
		add(north, new DigitalIO_PWMOut(9));
		add(north, new DigitalIO(8));
		add(north, new DigitalIO(7));
		add(north, new DigitalIO_PWMOut(6));
		add(north, new DigitalIO_PWMOut(5));
		add(north, new DigitalIO(4));
		add(north, new DigitalIO_PWMOut(3));
		add(north, new DigitalIO(2));
		add(north, new DigitalIO(1));
		add(north, new DigitalIO(0));
		north.setMinimumSize(d4);
		north.setPreferredSize(d4);
		north.setMaximumSize(d4);
		add(north);

		final BackgroundImage img = new BackgroundImage("Duemilanove.jpg");
		img.setMinimumSize(d2);
		img.setPreferredSize(d2);
		img.setMaximumSize(d2);
		add(img);

		final JPanel south = new JPanel();
		south.setBackground(Color.WHITE);
		south.setLayout(new GridLayout(1, 14));
		south.add(new JLabel(""));
		south.add(new JLabel(""));
		south.add(new JLabel(""));
		south.add(new JLabel(""));
		south.add(new JLabel(""));
		south.add(new JLabel(""));
		south.add(new JLabel(""));
		south.add(new JLabel(""));
		add(south, new AnalogIn(5));
		add(south, new AnalogIn(4));
		add(south, new AnalogIn(3));
		add(south, new AnalogIn(2));
		add(south, new AnalogIn(1));
		add(south, new AnalogIn(0));
		south.setMinimumSize(d4);
		south.setPreferredSize(d4);
		south.setMaximumSize(d4);
		add(south);
	}
}
