import javax.swing.*;
import java.awt.*;

public abstract class Pin extends JPanel implements PinChangeListener {
	// Can be ORed...
	public static final int DIGITAL_IN = 1, DIGITAL_OUT = 2, ANALOG_IN = 4, ANALOG_OUT = 8;

	public final Color BORDER_INVALID = getBackground();
	public final Color BORDER_OUTPUT = new Color(210, 210, 240);
	public final Color BORDER_INPUT = new Color(240, 225, 210);

	protected PinChangeListener pinChangeListener;
	protected int id;

	public abstract void setMode (final MODE mode);

	public abstract void setAD (final AD ad);

	public abstract int getFeatures ();

	public abstract void hasBeenReadFrom ();

	public int getId () {
		return id;
	}

	public void addChangeListener (final PinChangeListener pinChangeListener) {
		this.pinChangeListener = pinChangeListener;
	}

	protected static void error (final String string) {
		System.err.println(
			(System.currentTimeMillis() % 1000) + " " +
				Thread.currentThread().getStackTrace()[2].getClassName() + "(" +
				Thread.currentThread().getStackTrace()[2].getLineNumber() + "): " +
				string
		);
	}
}
